#ifndef _Agenda_H_
#define _Agenda_H_

#include "Dbug.hpp"
#include "Item.hpp"

using namespace std;

class Item;

//! An abstract Agenda class.
class Agenda {
public:
  //! Constructor.
  Agenda() {}

  //! Destructor.
  virtual ~Agenda() {}

  //! Push in.
  virtual void push(Item* const& item) = 0;

  //! Pop.
  virtual void pop() = 0;

  //! Top.
  virtual Item* const & top() const = 0;

  //! Clears the content of the Agenda.
  virtual void clear() = 0;

  virtual size_t size() const = 0;

  virtual bool empty() const =0;

  //! Dumps the content for diagnostics.
  virtual void dump(ostream& out) const = 0;

  //! Check whether an item has already been on the agenda.
  virtual bool exists(const Item&) const = 0;

  virtual void dump_f_costs(ostream& o) const {}
};

#endif
