#ifndef AGENDASEARCHSTRATEGY_H
#define AGENDASEARCHSTRATEGY_H

#include "SearchStrategy.hpp"
#include "Agenda.hpp"

class Agenda;

class AgendaSearchStrategy : public SearchStrategy {

public:
  //! Default Constructor
  AgendaSearchStrategy() {}

  //! Constructor
  AgendaSearchStrategy(const string &configFile);

  //! Destructor
  virtual ~AgendaSearchStrategy();

  //! Add an item to the agenda
  virtual void addItem(Item* item);

  //! get the next item to be parsed
  virtual Item* nextItem();

  //! Clears the content of the SearchStrategy.
  void clear();

  size_t size() const;

  bool empty() const;

  //! Dumps the content for diagnostics.
  void dump(ostream& out) const;

  //! Check whether an item has already been seen by the search strategy
  bool exists(const Item &item) const;

protected:
  Agenda *m_pAgenda;
};

#endif

