#include "Bigram.hpp"
#include "GlobalVocab.hpp"
#include "Exceptions.hpp"
#include "GPDefs.hpp"
#include "Nonterminal.hpp"
#include <string>

//! output
ostream& operator << (ostream& out, const Bigram& obj){
  obj.put(out);
  return out;
}

//! input
istream& operator >> (istream& in, Bigram& obj) {
  obj.get(in);
  return in;
}

//! Input.
istream& Bigram::get(istream& in) {
  Terminal t1, t2;
  //  if(GlobalVocab::s_noVocabsIn){
  string str1;
  string str2;
  
  in >> str1 >>   str2;
  
  //!TODO this needs to be dynamic    
  StringVocabulary vocab = *GlobalVocab::s_terminalSet;
  
  t1 = vocab.addWord(str1);
  t2 = vocab.addWord(str2);
  //  }
  //  else{
  //    in >> t1 >> t2;
  //  }
  
  this->first = t1;
  this->second = t2;
  return in;
}




ostream& Bigram::put(ostream& out)const{
  //  if(GlobalVocab::s_noVocabsOut){
  //!TODO this needs to be dynamic    
  StringVocabulary vocab = *GlobalVocab::s_terminalSet;
  /*nonterminal*/
  bool exists;
  const string* t1 = vocab.getWord(this->first, exists);
  if(!exists){
    THROW((*this).first << " cannot be found!" << endl);
  }
  out << *t1;
  out << '\t';
  const string* t2 = vocab.getWord(this->second, exists);
  if(!exists){
    THROW((*this).second << " cannot be found!" << endl);
  }
  out << *t2;
  
  return out;
  //  }
  //  else{    
  //    out << this->first << '\t' << this->second;
  //  }
  return out;
}
