#ifndef BIGRAM
#define BIGRAM

#include "Pair.hpp"
#include "GPDefs.hpp"
#include "Nonterminal.hpp"

//! Bigram is just a pair of terminals with i/o methods.
class Bigram: public Pair<Terminal>{
public:
  Bigram(){};

  Bigram(Terminal t1, Terminal t2):Pair<Terminal>(t1,t2){};
  
  //! output
  friend ostream& operator << (ostream& out, const Bigram& obj);
  
  //! input
  friend   istream& operator >> (istream& in, Bigram& obj);
  
  //! Input.
  istream& get(istream& in);
  
  //!output
  ostream& put(ostream& out)const;
 };

namespace HashNS {
  template<> class hash< Bigram > {
  public:
    size_t operator() (const Bigram& b) const
    { return b.hash(); }
  };
}

#endif
