#include <string>
#include "BigramActiveFilter.hpp"
#include "SentenceTuple.hpp"
#include "Vector.hpp"
#include "GPDefs.hpp"

// hash each word we have seen.  If we encounter an unseen word, then 
// include that example in our training set

bool BigramActiveFilter::filter(SentenceTuple example) {
  bool include = false;
  // A single observation sequence represents the terminals in
  // one dimension of the SentenceTuple.  

  vector< Vector<Terminal> >::iterator obsIt;
  // for ( obsIt = example.begin(); obsIt != example.end(); ++obsIt){
  Vector<Terminal> sent = example[0];
  // check that a word hash exists, create one if it does not
  vector<Terminal>::iterator wordIt;
  Terminal curr = UNDEF_T;
  Terminal prev = UNDEF_T;

  for (wordIt = sent.begin(); wordIt != sent.end(); ++wordIt){
    // get the word from the tuple
    curr = *wordIt;
    // check the hash
    Bigram last2(prev, curr);
    if(m_pBigramHash->find(last2) != m_pBigramHash->end()){
      m_pBigramHash->increment(last2);
    } else {
      m_pBigramHash->insert(last2, UNITYSCORE);
        include = true;
    }
    prev = curr;
  }
  if (!include){
    filterExample(example);
  }

  return include;    
};

void BigramActiveFilter::clear(){
  m_pBigramHash->clear();
}



