#ifndef _BigramActiveFilter_H_
#define _BigramActiveFilter_H_

#include "ActiveLearningFilter.hpp"
#include <vector>
#include "ScoreSet.hpp"
#include "GPDefs.hpp"
#include "Bigram.hpp"

//!  NullActiveFilter simply returns true for all examples
 
class BigramActiveFilter : public ActiveLearningFilter {

  typedef ActiveLearningFilter _base;

public:

  BigramActiveFilter(){ 
    m_pBigramHash = new ScoreSet<Bigram>();
  }

  ~BigramActiveFilter() {
    m_pBigramHash->clear();
    delete m_pBigramHash;
  }

  /**
   * This method will will compare the given supervisory and
   * learner parses and return an appropriately updated model
   */
  bool filter(SentenceTuple example);

  /**
   *  This method will empty the list of seen words
   */
  void clear();
private:

ScoreSet<Bigram>* m_pBigramHash;

};

#endif
