#ifndef _BIGRAMGRAMMAR_H_
#define _BIGRAMGRAMMAR_H_

#include "BigramProbs.hpp"
#include <boost/program_options.hpp>
#include "OptionsPrinter.hpp"
#include "WMTG.hpp"
#include "Path.hpp"
#include "GlobalVocab.hpp"
#include "Hedge.hpp"

using namespace std;

/// Bigram Grammar as in Melamed @ TMI'04
/// \todo does not yet account for string start and end
class BigramGrammar : public WMTG {

public:
  BigramGrammar() { }

  BigramGrammar(const string& configFile);

  virtual ~BigramGrammar() {}

  virtual std::istream& get(std::istream&){THROW("Function not implemented")}
  virtual std::ostream& put(std::ostream&) const{THROW("Function not implemented")}

  // assumes that parents have been proposed by another grammar higher up the chain of responsibility (pattern)
  virtual void getPossibleConsHeaded(const Item*, const Item*, const Pair<bool, PAV>&, vector<HRVIpair>&);
  // assumes that parents have been proposed by another grammar higher up the chain of responsibility (pattern)
  virtual void getPossibleConsForTLink(const TLink&, const DSV&, vector<Item* >& ret) const;

private: // methods
  SCORE mixInScoreForTerminal(const Terminal& theTerm) const;
  SCORE mixInScoreForNonTerminal(const Terminal& leftMost, const Terminal& rightMost) const;

private: // data

  BigramProbs m_bigrams;

};

#endif // _BIGRAMGRAMMAR_H_
