#include "BigramProbs.hpp"

#ifdef USE_KH_NGRAMS

// sorry, these variables must be global, due to mysterious memory issue with member variables here
backoff::base<NGRAM_SIZE> khBigramBase; // base holds the training and heldout data
backoff::dist<NGRAM_SIZE>* keith_bigram_prob;
backoff::dist<NGRAM_SIZE>* keith_unigram_prob;

void BigramProbs::loadModel(const string& modelFileStem) {

  std::string mFile;

  mFile = modelFileStem;
  mFile += ".data";
  iFile boiFile(mFile.c_str());
  if (!boiFile) THROW("Error opening model data file:" << mFile.c_str());
  boiFile >> khBigramBase;
  DEBUG(4, "Base train size: " << khBigramBase.train.size() << std::endl);
  DEBUG(4, "Base heldout size: " << khBigramBase.heldout.size() << std::endl);
  boiFile.close();

  mFile = modelFileStem;
  mFile += ".dist";
  boiFile.open(mFile.c_str());
  if (!boiFile) THROW("Error opening model dist file:" << mFile.c_str());
  boiFile >> *keith_bigram_prob;
  DEBUG(4, "Base train size: " << khBigramBase.train.size() << std::endl);
  DEBUG(4, "Base heldout size: " << khBigramBase.heldout.size() << std::endl);
  boiFile.close();

  boiFile >> *keith_bigram_prob;
  boiFile.close();

  mask un_m;
  constraints un_c;
  keith_unigram_prob = new backoff::dist<NGRAM_SIZE>(khBigramBase, 0, un_m, un_c);

}

#endif // USE_KH_NGRAMS

