
#include "CSHeadCompose.hpp"
#include "MoreComparators.hpp"

// //! constructor from superclass and additional info
///////// for some reason, gcc won't give access to the super's members here
// CSHeadCompose::CSHeadCompose(const HeadCompose* pHC, 
// 			     FeatVecType& featVec)
//   : _super(pHC->m_hedgeAnts[0], pHC->m_hedgeAnts[1], pHC->m_pHedgeCon, 
// 	   pHC->m_arrgment, pHC->m_heirIndices), 
//     m_featVec(featVec) 
// {};

//! constructor from superclass and additional info
CSHeadCompose::CSHeadCompose(const Item *hedge1,
			     const Item *hedge2,
			     Hedge *hedgeCon,
			     const Pair<bool,PAV> & arrg,
			     const HeirRoleVector heirIndices,
			     const FeatVecType& featVec)  
  : _super(hedge1,hedge2,hedgeCon,arrg,heirIndices), m_featVec(featVec)
{};

//! destructor
CSHeadCompose::~CSHeadCompose() {}

void CSHeadCompose::dump(ostream& out) const {
  _super::dump(out);
  out << " FeatVec:";
  FeatVecType::const_iterator fvci = m_featVec.begin();
  const FeatVecType::const_iterator sentinel = m_featVec.end();
  while(fvci != sentinel) {
    out << " && "  << fvci->second << " " << *(GlobalVocab::s_featSet->getWord(fvci->first));
    ++fvci;
  }
};

//! returns true if equal.
bool CSHeadCompose::equalTo(const Inference& other) const {
  if (not _super::equalTo(other))
    return false;
  
  const CSHeadCompose* pCSHC = dynamic_cast<const CSHeadCompose*>(&other);
  if (not pCSHC)
    return false;
  if (not (m_featVec == pCSHC->m_featVec))
    return false;
  
  return true;
};

//! compare two inferences.
int CSHeadCompose::cmp(const Inference* other) const {
  int ret;
  if ((ret = _super::cmp(other)) != 0)
    return ret;

  const CSHeadCompose* pCSHC = dynamic_cast<const CSHeadCompose*>(other);
  if (not pCSHC)
    THROW("not a CSHC");

  return MC::cmp(m_featVec, pCSHC->m_featVec);
};

void CSHeadCompose::append(FeatVecType& vec){
  m_featVec.insert(m_featVec.end(), vec.begin(), vec.end());
}
