#ifndef _CSHeadCompose_H_
#define _CSHeadCompose_H_

#include "HeadCompose.hpp"
#include "GlobalVocab.hpp"
#include "WVector.hpp"

//! The Compose inference rule which includes heads.
//! It is a template class parameterized over span arrangement.

class CSHeadCompose : public HeadCompose {
  typedef HeadCompose _super;
  typedef WVector<GlobalVocab::FeatureType> FeatVecType;

public:

  //! constructor
  ///////// for some reason, gcc won't give access to the super's members here
  //  CSHeadCompose(const HeadCompose*, WVector<GlobalVocab::FeatureType>&);

  CSHeadCompose(const Item *hedge1, const Item *hedge2,	Hedge *hedgeCon,
		const Pair<bool,PAV> & arrg, const HeirRoleVector heirIndices,
		const FeatVecType& featVec = FeatVecType());

  //! destructor
  ~CSHeadCompose();

  // returns a copy of this
  virtual Inference* clone() const{
    return new CSHeadCompose(*this);
  }

  FeatVecType& getFeatVec() {return m_featVec;}
  const FeatVecType& getFeatVec() const {return m_featVec;}

  void dump(ostream& out) const;

  //! returns true if equal.
  bool equalTo(const Inference& inf) const;

  //! compare two inferences.
  int cmp(const Inference* inf) const;

  //! incrememnt these features into the featVec
  void append(FeatVecType& vec);

protected: // data

  FeatVecType m_featVec;

};

#endif

