
#ifndef CHARTBUILDER_H
#define CHARTRBUILDER_H

#include "Dbug.hpp"
#include "Chart.hpp"
#include "ItemSet.hpp"
#include <vector>

using namespace std;

class ChartBuilder : public Dbug {

 public:
  //! Returns a pointer to the instance of this class.
  static ChartBuilder* Instance();

  /**
  * Builds the chart based on a configure file. 
  *
  * @param configFile The config file of the chart.
  */
  Chart* build(const string& configFile,
		 BSP<BPO::options_description> priorOptions =
	         BSP<BPO::options_description>(new BPO::options_description()));

 protected:
  ChartBuilder(){}

 private:
  static ChartBuilder* _instance;

};

#endif
