#include "FeatureGrammar.hpp"

BSP<BPO::options_description> 
addOptionDescriptionsTo(BSP<BPO::options_description> optionsDescription) {
  return optionsDescription;
}

FeatureGrammar::FeatureGrammar(arity_t arity, const string& configFile,
			       BSP<BPO::options_description> priorOptions = 
			       BSP<BPO::options_description>(new BPO::options_description())) 
  : _super(arity),
    m_pSentTuple(NULL) {};

// Updates the content of the grammar.
bool FeatureGrammar::prepareFor(SentenceTuple& tuple) {
  // remember the current sentence
  m_pSentTuple = &tuple;

  return true;
}

/// overrides superclass to get context-aware features of a consequent
void FeatureGrammar::getFeats(Hedge* pConseq, Vector<Weighted<GlobalVocab::FeatureType> >& featVec)
{ THROW("Not implemented"); }

//! Decompose a multitree in the way specified by the grammar and learn from it.
void FeatureGrammar::increment(HeadMTree&, SCORE = UNITYSCORE) { THROW("Not implemented"); }

//! Increment features from another grammar
void FeatureGrammar::increment(const Grammar* ) { THROW("Not implemented"); }

//! return the sum of the scores of all features
SCORE FeatureGrammar::mass() { THROW("Not implemented"); }

/// call-back method to simulate template parameter for UpdateRule::trees2gradient()
/// computes the margin and return its total cost
SCORE FeatureGrammar::trees2gradient(const vector<HeadMTree::iterator>& supervisorMargin, 
				     const vector<HeadMTree::iterator>& learnerMargin,
				     const vector<HeadMTree::iterator>& intersectionMargin,
				     Grammar* pCurrModel,
				     const UpdateRule* uRule) { THROW("Not implemented"); }

//! create an inference from the given tree node and add it to the set
void FeatureGrammar::treeNode2infs(HeadMTree::iterator& it, DSV& theDSV, Vector<Inference*>& ret) {

};
