
#ifndef GPDEFS_H
#define GPDEFS_H

#include "BoostMacros.hpp"
#include "Terminal.hpp"
#include "SynCat.hpp"

using namespace std;

#define GP_DEBUG 1

//! For referring to or counting dimensions
typedef unsigned char arity_t;

//! MAX_UINT
extern const unsigned int MAX_UINT ;

//! possible results of item memoization
//!            - INSERT: the item inserted is new;
//!            - UPDATE: there is an item with the same signature already
//!                      in chart, and the inside score of the inserted
//!                      item is larger than the old one;
//!            - NOEFFECT: there is an item with the same signature
//!                      already in chart, and has larger inside score;
//!            - IGNORE: this item is ignored, e.g. because of being pruned or having
//!                      negative infinity score.
enum MemoResult { INSERT, UPDATE, NOEFFECT, IGNORE};

#endif
