#ifndef _HEDGE_DC_INTERFACE_H_
#define _HEDGE_DC_INTERFACE_H_

#include "Item.hpp"
#include "DSV.hpp"
#include "DSpan.hpp"
#include "DiscChartGlobals.hpp"

// Class to be used to create instance of DiscChart.

class GPDiscChartInterface {
 typedef DSpan::Span Span;

public:
  disc_chart::Index operator()( const Item& h, int gd, int sp, bool isRight) {
    const DSV* pDSV = h.getDSV();
    FanoutVect fv = h.getFanoutV(); 

    const DSpan dspan = (*pDSV)[gd]; 

    unsigned short span_cnt  = fv[gd]; //number of spans in this grammar dim
    assert(span_cnt >= dspan.size() ); 

    //if the sp-th span exists in this grammar dimension
    if( sp >= span_cnt ) {
      //cout<<h<<"-"<<gd<<"-"<<isRight<<" *2* DCIResult: DEGEN"<<endl;
      return DEGEN;
    } else if ( span_cnt > dspan.size()) { //if no index info exists
      //cout<<h<<"-"<<gd<<"-"<<isRight<<" *2* DCIResult: 0 (NON-DEGEN)"<<endl;
      return 0; //sentinal value: not degenerate 
    }

    const Span span = dspan[sp];
    disc_chart::Index res = isRight ? span.second : span.first;
    //cout<<h<<"-"<<gd<<"-"<<isRight<<" *3* DCIResult:"<<res<<endl;
    return res;
  }
};

#endif
