#ifndef GLOBALVOCAB_H
#define GLOBALVOCAB_H 1

#include "StringVocabulary.hpp"
#include "GPDefs.hpp"

class GlobalVocab{

public: // data

  //! Terminal sets
  static StringVocabulary* s_terminalSet;

  //! SynCat sets
  static StringVocabulary* s_synCatSet;

  /// feature set
  typedef VocabularyIndex FeatureType;
  static StringVocabulary* s_featSet;

  static bool s_noVocabsIn;
  static bool s_noVocabsOut;
  static arity_t s_ioDIM;
  static arity_t s_arity;

public: // methods

  static void addPreDefinedSynCat(StringVocabulary& vcb);
  static void addPreDefinedTerminal(StringVocabulary& vcb);
  static StringVocabulary* initNTVocab();
  static StringVocabulary* initTermVocab();

  //! output
  //  friend ostream& operator<<(ostream& out, const GlobalVocab& vcbd);
  static ostream& put(ostream& out);

} ;

#endif
