#ifndef GradientMSTEP_H
#define GradientMSTEP_H

#include "MStep.hpp"

//! A class to manage the M step of the EM algorithm.
class GradientMStep: public MStep {
public:

  //! Runs the M-step, which is essentially a normalization.
  /// oldModel gets updated according to newModel
  /// The oldModel pointer is passed by reference, so that the revised
  /// pointer is correct for the caller.
  virtual LearnableGrammar* minimizeCost(LearnableGrammar*& model, LearnableGrammar*& gradient) const;
};
#endif
