#include "GlobalVocab.hpp"
#include "Grammar.hpp"

//! constructors
Grammar::Grammar(arity_t dim)
  : m_arity(dim){}

//! destructor
Grammar::~Grammar() {};

//! assignment
Grammar& Grammar::operator=(const Grammar& other) {
 m_arity = other.m_arity;
 return (*this);
}

//! Returns the dimensionality.
arity_t Grammar::arity() const {
  return m_arity;
}

//! Returns the dimensionality.
size_t Grammar::size() const {
  THROW("Undefined");
  return 0;
}

//! Returns the sets of nonterminals used in this grammar.
StringVocabulary* Grammar::ntSet() {
  return GlobalVocab::s_synCatSet;
}
const StringVocabulary* Grammar::ntSet() const {
  return GlobalVocab::s_synCatSet;
}
StringVocabulary* Grammar::terminalSet() {
  return GlobalVocab::s_terminalSet;
}
const StringVocabulary* Grammar::terminalSet() const {
  return GlobalVocab::s_terminalSet;
}

/** Clears the content (only) of the containers. */
void Grammar::clear(){}

