#ifndef HASW2WDICT_H
#define HASW2WDICT_H

#include "GPDefs.hpp"

using namespace std;

/// Interface to W2W dictionaries.  Classes that inherit from this
/// interface must implement methods to return a W2W dictionary.
/// Usually these subclasses will be grammars.
class HasW2WDict {

public:
  virtual ~HasW2WDict() {};

  /// Compile w2w model from the productions, assuming GCNF.
  /// Currently, this ignores links involving a null in the 0th
  /// component.
  virtual BSP<W2WDictionary> getW2WDict() const = 0;

};

#endif
