#include "HeadMTreeNode.hpp"

Vector<unsigned int>& HeadMTreeNode::getHRV() {
  return m_HRV;
};
const Vector<unsigned int>& HeadMTreeNode::getHRV() const {
  return m_HRV;
};

/*
 * print the tree node. Argument penn makes the output consistent
 * with the PTB if its value is set true. Note that when ptbII is
 * true, the tree node must be monolingual.
 */
void HeadMTreeNode::print(ostream& out,
			  StringVocabulary* ntSet, StringVocabulary* terminalSet, bool ptbII) {
  const HeadMTreeNode& theNode = *this;
  if(boost::get<const TLink>(&BGET_EITHER_LABEL(theNode))){
    BGET_TERM_LABEL(theNode).put(out, terminalSet);
  }
  else if(boost::get<const Pair<TLink,DSV> >(&BGET_EITHER_LABEL(theNode))){
    Pair<TLink, DSV> p = BGET_TERM_SPAN_LABEL(theNode);
    p.first.put(out, terminalSet);
  }

  // if it is an internal node.
  else {
    out<<BGET_CONST_PAV(theNode);
    BGET_NT_LABEL(theNode).put(out, ntSet, terminalSet);
    out<<" ";
  }

}
