/// \brief node contents of Headed Multitree

#ifndef _HeadMTreeNode_H_
#define _HeadMTreeNode_H_

#include "BoostMacros.hpp"
#include "Dbug.hpp"
#include "DSV.hpp"
#include "PAV.hpp"
#include "NTLink.hpp"
#include "RHSElem.hpp"
#include "MTreeNode.hpp"

#define BGET_HEIR(it) static_cast<unsigned int>((it))
#define BGET_HEIRVEC(it) (it).getHRV()

class HeadMTreeNode: public MTreeNode {
  typedef MTreeNode _super;

public:

  HeadMTreeNode(unsigned int d): _super(d), m_HRV(d) {
    for(unsigned int i = 0; i < d; i++){
      m_HRV[i] = 0;
      BGET_NT_LABEL(*this).setNT(i,NULL);
    }
  };

  Vector<unsigned int>& getHRV();
  const Vector<unsigned int>& getHRV()const ;

  friend bool operator<(const HeadMTreeNode& t1, const HeadMTreeNode& t2);

  void print(ostream& out,
	     StringVocabulary* ntSet, StringVocabulary* terminalSet, bool ptbII);

protected:
  Vector<unsigned int> m_HRV;
};

#endif
