#ifndef _HeadPMTG_H_
#define _HeadPMTG_H_

#include "HeadWMTG.hpp"
#include "IndexedPMTG.hpp"
#include <boost/program_options.hpp>
#include <boost/serialization/serialization.hpp>

class HeadPMTG : public HeadWMTG, public IndexedPMTG {
  typedef HeadWMTG _super;
  typedef IndexedPMTG _indexed;

protected:
  typedef _super::iterator iterator;
  typedef _super::const_iterator const_iterator;

  // added for serialization, but kept protected from outside classes
  HeadPMTG();

public:

  /**
   * @param configFile The config file of the grammar.
   */
  HeadPMTG(arity_t dm,
	   const string& configFile,
	   char** overrideArgV = NULL,
	   size_t overrideArgC = 0,
	   BSP<BPO::options_description> priorOptions =
	   BSP<BPO::options_description>(new BPO::options_description())
	   );

  //! Destructor.
  virtual ~HeadPMTG(){};

  virtual void increment(Production* pProd, SCORE score);

protected:
  virtual SCORE getProdScore(Production* rule) const;

};

#endif
