#ifndef _IndexedPMTG_H_
#define _IndexedPMTG_H_

#include "IndexedWMTG.hpp"
#include <boost/program_options.hpp>
#include <boost/serialization/serialization.hpp>

class IndexedPMTG : virtual public IndexedWMTG {
  typedef Grammar _grammar;
  typedef IndexedWMTG _super;

protected:
  typedef _super::iterator iterator;
  typedef _super::const_iterator const_iterator;

  // added for serialization, but kept protected from outside classes
  IndexedPMTG();

public:

  /**
   * @param configFile The config file of the grammar.
   */
  IndexedPMTG(arity_t dm,
	      const string& configFile,
	      char** overrideArgV = NULL,
	      size_t overrideArgC = 0,
	      BSP<BPO::options_description> priorOptions =
	      BSP<BPO::options_description>(new BPO::options_description())
	      );

  //! Destructor.
  virtual ~IndexedPMTG(){};

  //! input
  virtual istream& get(istream& is);

  //! output
  virtual ostream& put(ostream& os) const;

  virtual void estimate();

  //! The cost associated with having this item as a root.
  virtual SCORE rootCost(const Item*) const;

protected: // data
  Histogram<NTLink> m_prodLHSScore;

};

#endif
