#include "Inference.hpp"
#include "HeirRoleVector.hpp"

/// constructors
Inference::Inference(const PAV& thePAV) : m_PAV(thePAV), m_headIsFirst(true) {};
Inference::Inference(const PAV& thePAV, const bool headIsFirst) 
  : m_PAV(thePAV), m_headIsFirst(headIsFirst) 
{};

//! Destructor.
Inference::~Inference(){}

bool Inference::equalTo(const Inference& inf) const {
  if (! (m_PAV == inf.m_PAV))
    return false;
  if (! (m_headIsFirst == inf.m_headIsFirst))
    return false;

  return true;
};

int Inference::cmp(const Inference* inf) const {
  int ret;
  if (((ret = m_PAV.cmp(inf->m_PAV))) != 0)
    return ret;
  if (((ret = MC::cmp(m_headIsFirst,inf->m_headIsFirst))) != 0)
    return ret;

  return 0;
};

const PAV Inference::getPAV() const {
  return m_PAV;
};
PAV Inference::getPAV() {
  return m_PAV;
};

const Pair<bool,PAV> Inference::getArnmt() const {
  return Pair<bool,PAV>(m_headIsFirst,m_PAV);
};
Pair<bool,PAV> Inference::getArnmt() {
  return Pair<bool,PAV>(m_headIsFirst,m_PAV);
};

//! output adaptors
ostream& operator<<(ostream& o, const Inference& inf) {
  inf.dump(o);
  return o;
};
ostream& operator<<(ostream& o, Inference* pI) {
  pI->dump(o);
  return o;
};

void Inference::dump(ostream& out) const {
  out << "Inf# " << m_uniqueID;
  out << " PAV: " << m_PAV;
  if (m_headIsFirst)
    out << " Head1 ";
  else
    out << " Head2 ";
  out << *getConseq();
}

//! Print out the inference, where terminals are strings, instead of ids.
void Inference::dump(ostream& out, StringVocabulary* terminalSet) const 
{}

//! Print out the inference, where terminals and nonterminals are strings,
//! instead of ids.
void Inference::dump(ostream& out, StringVocabulary* terminalSet,
		     StringVocabulary* nonTermSet) const
{}
