#ifndef _ItemIndex_H_
#define _ItemIndex_H_

#include "Item.hpp"

//! The index to edges in Chart.
class ItemIndex {
public:
    enum ItemIndexType {FACTORED, NAIVE, NONE};

    ItemIndex() {}
    virtual ~ItemIndex() {}

    //! Retrieves all the edges covering the d-th component
    //! of the input span. And returns the maximum value
    //! over all the returned items.
    virtual SCORE
	retrieve(const DSV&, arity_t d, vector<Item*>& ) const =0;

    //! Insert the index to an item.
    virtual void insert(const Item*) = 0;

    //! How many factored indexes are there?
    virtual size_t numFactors() const = 0;

    virtual void clear() = 0;
};
#endif
