/*! \file LogicBuilder.hpp
 * \brief LogicBuilder class.
 * created Wed Mar 2 21:13:50 EST 2005
 * header by mkh script
 */

#ifndef LOGICBUILDER_H
#define LOGICBUILDER_H

#include "Dbug.hpp"

class Logic;
class Grammar;

using namespace std;

class LogicBuilder : public Dbug {

 public:
  //! Returns a pointer to the instance of this class.
  static LogicBuilder* Instance();

  //! generate Scan inferences.
  Logic* build(const string& configFile);

  static void clear(){
    delete _instance;
  }

 protected:
  LogicBuilder(){}

 private:
  static LogicBuilder* _instance;

};

#endif
