#include "NameAddressMap.hpp"
#include "ValencyEvent.hpp"
#include "HeirRoleVectorEvent.hpp"
#include "NTLink.hpp"
#include "HeirEvent.hpp"
#include "Dependency.hpp"
#include "Vector.hpp"
#include <boost/bind.hpp>
#include "boost/variant.hpp"
#include <string>
#include "ImDom.hpp"
#include "PAOrderEvent.hpp"

NameAddressMap::NAMapType& NameAddressMap::initNameMap() {
  NAMapType& theMap = *(new NAMapType);

  boost::_mfi::cmf0<ValencyEvent::FirstType, ValencyEvent>* p1 =
    new boost::_mfi::cmf0<ValencyEvent::FirstType, ValencyEvent>( boost::mem_fn((( NTLink (ValencyEvent::*)()const)(&ValencyEvent::link))));
  theMap[((char*)p1)]="boost-cmf0-ValencyEvent";

  boost::_mfi::cmf0<HeirRoleVectorEvent::FirstType, HeirRoleVectorEvent>* p2 =
    new boost::_mfi::cmf0<HeirRoleVectorEvent::FirstType, HeirRoleVectorEvent>(boost::mem_fn(( HeirRoleVectorEvent::FirstType (HeirRoleVectorEvent::*)()const)& HeirRoleVectorEvent::getParValPair));
  theMap[((char*)p2)]="boost-cmf0-HeirRoleVectorEvent";

  boost::_mfi::cmf0<NTLink, HeirEvent>* p3 =
    new boost::_mfi::cmf0<NTLink, HeirEvent> (boost::mem_fn(&HeirEvent::getParent));
  theMap[((char*)p3)]="boost-cmf0-NTLink-HeirEvent";

  boost::_mfi::cmf0<NTLink, Dependency>* p4 =
    new boost::_mfi::cmf0<NTLink, Dependency>(boost::mem_fn((NTLink (Dependency::*)() const)&Dependency::getParent));
  theMap[((char*)p4)]="boost-cmf0-NTLink-Dependency";

  boost::_bi::bind_t<Vector<unsigned short>, boost::_mfi::cmf1<Vector<unsigned short>, Dependency, unsigned short>,
      boost::_bi::list2<boost::arg<1>, boost::_bi::value<unsigned short> > >* p5 =
    new boost::_bi::bind_t<Vector<unsigned short>,
      boost::_mfi::cmf1<Vector<unsigned short>, Dependency, unsigned short>,
    boost::_bi::list2<boost::arg<1>, boost::_bi::value<unsigned short> > >(boost::bind<Vector<unsigned short> >(boost::mem_fn(&Dependency::getFromDesc), _1, (unsigned short)(0)));
  theMap[((char*)p5)]="boost-bind-0";

  boost::_bi::bind_t<Vector<unsigned short>, boost::_mfi::cmf1<Vector<unsigned short>, Dependency, unsigned short>,
      boost::_bi::list2<boost::arg<1>, boost::_bi::value<unsigned short> > >* p6 =
    new boost::_bi::bind_t<Vector<unsigned short>,
      boost::_mfi::cmf1<Vector<unsigned short>, Dependency, unsigned short>,
    boost::_bi::list2<boost::arg<1>, boost::_bi::value<unsigned short> > >(boost::bind<Vector<unsigned short> >(boost::mem_fn(&Dependency::getFromDesc), _1, (unsigned short)(1)));
  theMap[((char*)p6)]="boost-bind-1";

  // m_permDistribs[0..d-1]
  boost::_mfi::cmf0<const PAOrderEvent::NTPair&, ImDom<PAOrderEvent::NTPair, PAV> >* p7 =
    new boost::_mfi::cmf0<const PAOrderEvent::NTPair&, ImDom<PAOrderEvent::NTPair, PAV> >(boost::mem_fn(( const PAOrderEvent::NTPair& ( ImDom<PAOrderEvent::NTPair, PAV>::*)()const)&PAOrderEvent::parent));
  theMap[((char*)p7)]="boost-cmf0-NTPair-0";

  boost::_mfi::cmf0<const PAOrderEvent::NTPair&, ImDom<PAOrderEvent::NTPair, PAV> >* p8 =
    new boost::_mfi::cmf0<const PAOrderEvent::NTPair&, ImDom<PAOrderEvent::NTPair, PAV> >(boost::mem_fn((const PAOrderEvent::NTPair& ( ImDom<PAOrderEvent::NTPair, PAV>::*)()const)&PAOrderEvent::parent));
  theMap[((char*)p8)]="boost-cmf0-NTPair-1";

  return theMap;
}

NameAddressMap::ANMapType& NameAddressMap::initAddressMap() {
  ANMapType& theMap = *(new ANMapType);

  NAMapType :: const_iterator iter = m_NameAddressMap.begin();
  for(int i = 0; i < 8; i++) {
    // cout << iter->second << endl; - this is the string "boost-cmf0..."
    //cout << iter->first << endl; - this is the address
    theMap[iter->second] = (char*)iter->first;
    iter++;
  }

  return theMap;
}

void NameAddressMap::deleteNameAddressMap(){
  NAMapType :: const_iterator iter = m_NameAddressMap.begin();
  for(int i = 0; i < 8; i++) {
    delete iter->first;
    iter++;
  }
}


NameAddressMap::NAMapType NameAddressMap::m_NameAddressMap = initNameMap();

NameAddressMap::ANMapType NameAddressMap::m_AddressNameMap = initAddressMap();

