#include "NoiseFilterUpdateRule.hpp"
#include "Production.hpp"

/// compute the gradient for each feature -- here is the default for MLE
void NoiseFilterUpdateRule::
getFeatureGradients( size_t supervisorMarginSize, size_t learnerMarginSize,
		     size_t intersectionSize,
		     SCORE& supervisorGradient, SCORE& learnerGradient, 
		     SCORE& intersectionGradient,
		     SCORE& unseenFeatGradient) const {
  
  SCORE denom = (SCORE) (supervisorMarginSize+intersectionSize);
  supervisorGradient = -1.0 / denom;
  learnerGradient = 0;
  intersectionGradient = -1.0 / denom;
  unseenFeatGradient = 0;

  return;
};


SCORE NoiseFilterUpdateRule::
getGradientHelper(const WTreeVec& learnerParses, 
		  const WTreeVec& supervisoryParses,
		  vector<HeadMTree::iterator>& supervisorMargin, 
		  vector<HeadMTree::iterator>& learnerMargin, 
		  vector<HeadMTree::iterator>& vecIntersection) const {

  // find the nodes in each tree that don't correspond to anything in the other tree
  HeadMTree::twoSidedDiff(supervisoryParses, learnerParses, 
			  supervisorMargin, learnerMargin, 
			  vecIntersection, m_keepW2W, m_filterNoise);
  return 0; // dummy for now
}
