#ifndef _NoiseFilterUpdateRule_H_
#define _NoiseFilterUpdateRule_H_

#include "UpdateRule.hpp"
#include "HeadMTree.hpp"
#include "LearnableGrammar.hpp"
#include "SPVector.hpp"

using namespace std;

class NoiseFilterUpdateRule : public UpdateRule {
  typedef UpdateRule _super;

public:
  
  NoiseFilterUpdateRule(bool keepW2W = true, bool filterNoise = true)
    : _super(keepW2W), m_filterNoise(filterNoise) {}
  
  ~NoiseFilterUpdateRule() {}

  /// compute the gradient for each feature -- here is the default for MLE
  void getFeatureGradients( size_t supervisorMarginSize, size_t learnerMarginSize, 
			    size_t intersectionMarginSize,
			    SCORE& supervisorGradient, SCORE& learnerGradient, 
			    SCORE& intersectionGradient, SCORE& unseenFeatGradient) const;

protected: // methods
  virtual SCORE getGradientHelper(const WTreeVec& learnerParses, 
				  const WTreeVec& supervisoryParses,
				  vector<HeadMTree::iterator>& supervisorMargin, 
				  vector<HeadMTree::iterator>& learnerMargin, 
				  vector<HeadMTree::iterator>& vecIntersection) const;

protected: // data

  // if true, then we do noise filtering [to be documented]
  bool m_filterNoise;

};

#endif
