
#ifndef ProdRHSELEM_H
#define ProdRHSELEM_H

#include "TLink.hpp"
#include "NTLink.hpp"
#include "boost/variant.hpp"
#include "MoreComparators.hpp"

//! RHS elem gives flexibility to be terminals or nonterminals
typedef boost::variant<NTLink, TLink > ProdRHSElem;

namespace HashNS {
  //! Template specialization of STL's hash object.
  template<>
  class hash<ProdRHSElem > {
  public:
    size_t operator()(const ProdRHSElem& obj) const {
      if ( const NTLink* nt = boost::get<NTLink>( &obj ) )
        return nt->hash();
      else if( const TLink* t = boost::get<TLink>( &obj ))
        return t->hash();
      else
	THROW("Error: cannot hash this object." << endl);

      //not used
      return 0;
    }
  };
}

#endif
