/*! \file PrunerBuilder.hpp
 * \brief PrunerBuilder class.
 * created Wed Mar 2 21:13:50 EST 2005
 * header by mkh script
 */

#ifndef PRUNERBUILDER_H
#define PRUNERBUILDER_H

#include "PruningStrategy.hpp"
#include "Dbug.hpp"

using namespace std;

class PrunerBuilder : public Dbug {

 public:
  //! Returns a pointer to the instance of this class.
  static PrunerBuilder* Instance();

  //! build a pruning strategy
  PruningStrategy* build(const string& configFile);

  //! build one pruner
  PruningStrategy* buildOne(const string& prunerType, const string& configFile);

 protected:
  PrunerBuilder(){}

 private:
  static PrunerBuilder* _instance;

};

#endif
