#ifndef _PruningStrategy_H_
#define _PruningStrategy_H_

#include "Item.hpp"

//! Strategy of item pruning.
class PruningStrategy : public Dbug {
public:

  enum StrategyT {RELATIVE, /*!<relative beam pruning.*/
		                ABSOLUTE, /*!<absolute thresholding*/
			            COMB, /*!<RELATIVE + ABSOLUTE*/
                      ABSOLUTE_COUNT /* <fixed number of parses per span> */
		       };

  PruningStrategy() { };

  virtual ~PruningStrategy() { };

  virtual bool prunable(const Item* item) const = 0;

  /** Inserts an item into the item index table.*/
  virtual void memoize(const Item* item) { };

  //! how much will be increased (negative decreased).
  virtual void lowerTh() { };

  virtual void setTh(SCORE th) { };

  /**
   * Gets the original threshold.
   */
  virtual SCORE getOrigTh() const = 0;

  /**
   * Gets the current threshold (possibly raised from the original).
   */
  virtual SCORE getCurTh() const = 0;

  //! Reset the threshold.
  virtual void reset() { };
};

#endif
