#ifndef _SmallestSizeFirstComparator_H_
#define _SmallestSizeFirstComparator_H_

#include "Comparator.hpp"

using namespace std;

//! This is a comparator for agenda items that lets us use
//! agenda-based parsing as if it were BottomUp parsing.
class SmallestSizeFirstComparator : public Comparator{
public:

  SmallestSizeFirstComparator() {};
  virtual ~SmallestSizeFirstComparator() {};

  virtual bool operator()(const Item* a, const Item* b) const {

    int ret;
    /*
     * Partial language dimensions go before
     * full language dimensions.
     */
    if((ret = MC::cmp(a->numActiveDims(), b->numActiveDims())) != 0)
      return (ret > 0);
    /*
     * Small span size goes before larger span size.
     */
    if((ret = MC::cmp(a->volume(), b->volume())) != 0)
      return (ret > 0);

    /*
     * Small rank goes first than larger rank.
     */
    // if((ret = MC::cmp(a->typeRank(),
    // 			    b->typeRank())) != 0)
    // return (ret > 0);

    /*
     * Same type comparison.
     */
    return ((ret = a->cmp(b)) > 0);
  }

};

#endif
