#ifndef _SpanTree_C_
#define _SpanTree_C_

#include "SpanTree.hpp"
// for the macros...
#include "PositionTreeNode.hpp"
#include "tree.hpp"

template<class _DecoratedTree>
SpanTree<_DecoratedTree>::
SpanTree() {
  // __head_bk = this->getHead();
}

template<class _DecoratedTree>
SpanTree<_DecoratedTree>::
SpanTree(const _super& base) {
  //__head_bk = base.getHead();
  //setHead(base.getHead());
}

template<class _DecoratedTree>
SpanTree<_DecoratedTree>::~SpanTree() {}// setHead(__head_bk);}

template<class _DecoratedTree>
void SpanTree<_DecoratedTree>::
addSpan(iterator it, const DSV& span) {
  if(is_valid(it) && it != this->end()) {
    // because DSV+= will return empty DSV when
    // two DSVs are overlapped.
    if(!BGET_SPAN(*it).contains(span)) 
      BGET_SPAN(*it) += span;
    addSpan(parent(it), span);
  }
}

template<class _DecoratedTree>
void SpanTree<_DecoratedTree>::
removeSpan(iterator it, const DSV& span) {
  if(is_valid(it) && it != this->end()){
    it->removeSpan(span);
    removeSpan(parent(it), span);
  }
}

template<class _DecoratedTree> template<class iter>
iter SpanTree<_DecoratedTree>::
//addKids(iter position, const value_type& x)
append_child(iter position, const value_type& x) {
  iter it;
  // if empty tree, use set_head
  if(position == this->end()){
   it = (static_cast<HeirTree<tree<value_type> >&>(*this)).set_head(x);
  }
  else {
    it = (static_cast<HeirTree<tree<value_type> >&>(*this)).append_child(position, x);
    addSpan(position, BGET_SPAN(*it));
  }

  return it;
}

template<class _DecoratedTree> template<class iter>
iter SpanTree<_DecoratedTree>::
//addKids(iter position, const value_type& x)
append_child(iter position) {
  iter it;
  it = (static_cast<tree<value_type>&>(*this)).append_child(position);

  return it;
}

#endif
