
#ifndef SYNCAT_H
#define SYNCAT_H

using namespace std;

//Syntactic category (used to be nonterminal)
typedef unsigned int SynCat;

//! Global symbol for the null nonterminal, every language.
extern const SynCat NULLNT;

//! Global symbol for the root nonterminal in every language.
extern const SynCat Root;

//! Global preterminal for EOSH, every language.
extern const SynCat RootTag;

extern const SynCat DummyNT;

extern const SynCat UNKNT;

//! out of bounds, e.g. past end of sentence
extern const SynCat OutOfBoundsNT;

//! Unknown pre-terminal.
extern const SynCat UNK_PRTM;

//! Undefined SynCat, Pre-Terminal
extern const short UNDEF_POS;
extern const SynCat UNDEF_NT;
extern const SynCat UNDEF_PRTM;

#endif
