
#ifndef TERMINAL_H
#define TERMINAL_H

#include "Pair.hpp"
#include "MultiMap.hpp"

class TLink;

using namespace std;

//Terminal
typedef unsigned int Terminal;

//! W2W link and model type
typedef Pair<Terminal,Terminal> W2WLink;
typedef MultiMap<Terminal,Terminal> W2WDictionary;

//! Global symbol for the null terminal, every language.
extern const Terminal NULLT;

//! Unknown word in every language.
extern const Terminal Unknown;

//! Global symbol for the "end-of-sentence head" in every language.
extern const Terminal EOSH;

extern const Terminal DummyT;

extern const Terminal UNKT;

//! out of bounds, e.g. past end of sentence
extern const Terminal OutOfBoundsT;

//! Undefined Terminal
extern const Terminal UNDEF_T;
extern const Terminal HeirMark;

#endif
