/*! \file TerminationTestBuilder.hpp
 * \brief TerminationTestBuilder class.
 * created Wed Aug 10 18:13:50 EST 2005
 */

#ifndef PARSING_GOAL_BUILDER_H
#define PARSING_GOAL_BUILDER_H

#include "TerminationTest.hpp"
#include "NTLink.hpp"
#include "DSV.hpp"
#include "Dbug.hpp"

using namespace std;

class TerminationTestBuilder : public Dbug {

 public:
  //! Returns a pointer to the instance of this class.
  static TerminationTestBuilder* Instance();

  //! build a pruning strategy
  TerminationTest* build(const string& configFile, NTLink label, DSV span);

  //! build one pruner
  TerminationTest* buildOne(const string& prunerType, const string& configFile, NTLink label, DSV span);

 protected:
  TerminationTestBuilder(){}

 private:
  static TerminationTestBuilder* _instance;

};

#endif
