#include <string>
#include "UnseenActiveFilter.hpp"
#include "SentenceTuple.hpp"
#include "Vector.hpp"
#include "GPDefs.hpp"

// hash each word we have seen.  If we encounter an unseen word, then 
// include that example in our training set

bool UnseenActiveFilter::filter(SentenceTuple example) {
  bool include = false;
  // A single observation sequence represents the terminals in
  // one dimension of the SentenceTuple.  

  vector< Vector<Terminal> >::iterator obsIt;
  // for ( obsIt = example.begin(); obsIt != example.end(); ++obsIt){
  Vector<Terminal> sent = example[0];
  // check that a word hash exists, create one if it does not
  vector<Terminal>::iterator wordIt;
  for (wordIt = sent.begin(); wordIt != sent.end(); ++wordIt){
    // get the word from the tuple
    Terminal word = *wordIt;
    // check the hash
    if(m_pWordHash->find(word) != m_pWordHash->end()){
      m_pWordHash->increment(word);
    } else {
      m_pWordHash->insert(word, UNITYSCORE);
        include = true;
    }
  }
  if (include){
    filterExample(example);
  }
  return include;    
};

void UnseenActiveFilter::clear(){
  m_pWordHash->clear();
}


