#ifndef _UnseenActiveFilter_H_
#define _UnseenActiveFilter_H_

#include "ActiveLearningFilter.hpp"
#include <vector>
#include "ScoreSet.hpp"
#include "GPDefs.hpp"

//!  NullActiveFilter simply returns true for all examples
 
class UnseenActiveFilter : public ActiveLearningFilter {

  typedef ActiveLearningFilter _base;

public:

  UnseenActiveFilter(){ 
    m_pWordHash = new ScoreSet<Terminal>();
  }

  ~UnseenActiveFilter() {
    m_pWordHash->clear();
    delete m_pWordHash;
  }

  /**
   * This method will will compare the given supervisory and
   * learner parses and return an appropriately updated model
   */
  bool filter(SentenceTuple example);

  /**
   *  This method will empty the list of seen words
   */
  void clear();
private:

ScoreSet<Terminal>* m_pWordHash;

};

#endif
