#include "ValencyEvent.hpp"

/* Constructors */
//! Empty constructor.
ValencyEvent::ValencyEvent() {};

//! Default constructor.
ValencyEvent::ValencyEvent(const arity_t& dim) : _super(NTLink(dim), 0) {}

//! Useful constructor.
ValencyEvent::ValencyEvent(const NTLink& l, const short& v)
  : _super(l, v) {}

arity_t ValencyEvent::arity() const { return first.arity();}

/*
 * Operators.
 */
//! Equality test.
bool ValencyEvent::operator == (const ValencyEvent& other) const
{ assert(arity()); return _super::operator==(other);}

//! Assignment.
ValencyEvent& ValencyEvent::operator = (const ValencyEvent& other)
{ _super::operator=(other); return *this; }

//! Ordering.
bool ValencyEvent::operator< (const ValencyEvent& other) const
{ return _super::operator< (other);}
/*
 * Member access.
 */
//! Returns the link.
ValencyEvent::FirstType& ValencyEvent::link() { return first;}
ValencyEvent::FirstType ValencyEvent::link() const { return first;}

//! Returns the valency value.
short& ValencyEvent::valency() { return second;}
short ValencyEvent::valency() const { return second;}

/*
 * I/O
 */

ostream& ValencyEvent::put(ostream& out) const{
  return _super::put(out);
}

//! Read.
istream& ValencyEvent::get(istream& in) {
  return _super::get(in);
}

//! Input line by line.
istream& operator>>(istream& in, ValencyEvent& valE) {
  ValencyEvent::FirstType inputLNTL;
  in >> inputLNTL;

  ValencyEvent::SecondType inPE;
  in >> inPE;

  valE.link() = inputLNTL;
  valE.valency() = inPE;
  return in;
}

//! Output.
ostream& operator<<(ostream& out, const ValencyEvent& valE)
{out<<valE.first<<PAIRDELIM<<valE.second; return out;}

//! For hashing.
size_t ValencyEvent::hash () const
{ return _super::hash(); }
