#ifndef W2WTM_H
#define W2WTM_H

#include "GPDefs.hpp"

using namespace std;

/// Interface to a weighted W2W model.
class W2WTM {

public:
  typedef ScoreSet<W2WLink> W2WTMType;

  const W2WTMType& getW2WTM() const { return m_w2wTM;}
  W2WTMType& getW2WTM() { return m_w2wTM;}

protected:
  /// Compile w2w model from the productions, assuming GCNF.
  /// Currently, this ignores links involving a null in the 0th
  /// component.
  ScoreSet<W2WLink> m_w2wTM;

};

namespace std {
  // override less<Pair>, since score must be considered first
  template<>
  struct less<W2WLink> {
    bool operator()(const W2WLink p1, const W2WLink p2) const {
      return (p1.second < p2.second || p1.first < p1.first);
    }
  };
};

#endif
